package com.game 
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Anim;
	import net.flashpunk.graphics.Graphiclist;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.Sfx;
	/**
	 * ...
	 * @author Arthur Zeferino
	 */
	public class CrowdSprite extends Entity
	{
		[Embed(source = '../../../resources/crowdanim.png')]
		protected static const CROWDFILE:Class;
		
		[Embed (source = '../../../resources/crowdsound.mp3')]
		protected static const CROWDMP3:Class;			
		
		protected var crowdTiles:Array;
		public var crowdSound:Sfx;
		
		public function CrowdSprite() 
		{
			crowdTiles = new Array();
			for (var i:int = 0; i < 3; i++)
			{
				crowdTiles[i] = new Spritemap(CROWDFILE, 268, 91);
				crowdTiles[i].add("crowdmove", [0, 1], 0.1);
				crowdTiles[i].add("crowdmovefast", [0, 1], 0.2);
				crowdTiles[i].x = crowdTiles[i].width * i;
			}
			
			crowdSound = new Sfx(CROWDMP3);
			
			//crowdTiles[1].x += 35;
			//crowdTiles[2].x += 20;
			
			this.graphic = new Graphiclist(crowdTiles[0], crowdTiles[1], crowdTiles[2]);
		}
		
		public function animate(speed:int):void
		{
			var i:int;
			if (speed == 0 && crowdTiles[0].currentAnim != "crowdmove")
			{
				crowdSound.play(0.4);
				for (i = 0; i < 3; i++)
					crowdTiles[i].play("crowdmove");
			}
			else if (speed == 1 && crowdTiles[0].currentAnim != "crowdmovefast")
			{
				crowdSound.play(0.5);
				for (i = 0; i < 3; i++)
					crowdTiles[i].play("crowdmovefast");
			}
		}
		
		public function stopAnimate():void
		{
			if (crowdTiles[0].currentAnim != "")
			{
				for (var i:int = 0; i < 3; i++)
					crowdTiles[i].frame = 0;
			}
		}		
	}

}