package com.game
{
	import net.flashpunk.FP;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	
	public class FreeMode extends MainGame
	{
		protected static const RECORDMODE:Boolean = false;
		
		public function FreeMode()
		{
			stageNotes = new NoteList();
			NoteQueue = new Array();
			
			setGraphics();
			
			startSong();
		}
		
		override protected function startSong():void
		{
			stageNotes.stringPos = guitarString.y+20;
			stageNotes.fretBoard = fretBoard;
			stageNotes.worldPtr = this;
			songTimer = 0;
			
			finger.visible = true;
			guitarplayerSpt.visible = true;			
			
			drumsBGM.loop();
			
			started = true;
		}		
		
		override public function update():void
		{
			songTimer++;
			
			if (Input.mousePressed)
			{
				guitarString.stopVib();
				guitarString.press();
				finger.press();
				notePlayer.stop(20);
			}
			else if (Input.mouseReleased)
			{
				finger.release();
				guitarString.stopVib();
				guitarString.release();
				notePlayer.stop(40);	
			}
			
			if (Input.pressed("strum"))
			{
				strum();
				NoteQueue.push( { fret:getFret(), time:songTimer } );
				guitarplayerSpt.strum();				
			}
			
			finger.x = mouseX;
			if (finger.pressing)
			{
				var beforeFt:uint = getFret();
				finger.x = mouseX;
				var afterFt:uint = getFret();
				
				if (beforeFt != afterFt)
				{
					notePlayer.crossFadeto(beforeFt, afterFt);
				}
			}			
			
			if (Input.pressed(Key.ESCAPE))
			{
				if (!RECORDMODE)
					FP.world = new StartScreen();
				else
				{
					startSong();
					NoteQueue = new Array();
				}
			}
			
			guitarplayerSpt.setfret(getFret());			
			
			notePlayer.update();			
			
			if (Input.pressed(Key.P))
			{
				printRecordedSong();
			}
			
			//super.update();
		}	
		
		override protected function strum():void
		{
			var fret:uint = 0;
			if (finger.pressing)
			{
				fret = getFret();
				guitarString.vibrateAt(finger.x + 50);
				
				if (fret < 0) fret = 0;
				if (fret > 7) fret = 7;
			
				notePlayer.play(fret);				
			}
			else
			{
				guitarString.vibrateAt(0);
				notePlayer.play(8);
			}
			
			//blinkFret(fret);
			
		}		
		
		public function printRecordedSong():void
		{
			for (var i:int = 0; i < NoteQueue.length; i++)
			{
				trace(String(NoteQueue[i].fret) + "@" + String(NoteQueue[i].time));
			}
		}
	}
}