package com.game 
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Graphiclist;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Spritemap;
	/**
	 * ...
	 * @author Arthur Zeferino
	 */
	public class GuitarMan extends Entity
	{
		[Embed(source = '../../../resources/guitarbody.png')]
		private static const GUITARSPRITE:Class;
		
		[Embed(source = '../../../resources/bracoguitarra.png')]
		private static const ARMSPRITE:Class;		
		
		protected var guitarbody:Spritemap;
		protected var guitararm:Spritemap;		
		
		protected var idle:Boolean;
		
		public function GuitarMan() 
		{
			guitarbody = new Spritemap(GUITARSPRITE, 48, 105);
			guitararm = new Spritemap(ARMSPRITE, 42, 40);
			
			guitarbody.add("struming", [0, 1, 0], 0.05, false);
			guitarbody.add("idle", [2, 3], 0.05);
			
			guitararm.x = -36;
			guitararm.y = 24;
			
			guitararm.add("idle", [2, 3], 0.05);
			
			guitarbody.play("idle");
			guitararm.play("idle");
			
			idle = true;
			
			this.graphic = new Graphiclist(guitarbody, guitararm);
		}
		
		public function startPlaying():void
		{
			guitarbody.frame = 0;
			guitararm.frame = 0;
		}
		
		public function strum():void
		{
			idle = false;
			guitarbody.play("struming", true);
		}
		
		public function setfret(fret:uint):void
		{
			if (!idle)
			{
				if (fret < 3)
					guitararm.frame = 0;
				else if (fret < 6)
					guitararm.frame = 1;
				else
					guitararm.frame = 2;
			}
		}
		
	}

}
