package com.game 
{
	import flash.geom.Rectangle;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Canvas;
	import net.flashpunk.graphics.Graphiclist;
	import net.flashpunk.graphics.TiledSpritemap;
	import net.flashpunk.Tween;
	/**
	 * ...
	 * @author Arthur Zeferino
	 */
	public class GuitarString extends Entity
	{
		[Embed(source = '../../../resources/stringtile.png')]
		private static const STRINGTILE:Class;
		
		private var idleString:TiledSpritemap;
		private var movingString:TiledSpritemap;
		private var shadow:Canvas;
		
		private var shakeTween:Tween;
		
		public function GuitarString() 
		{
			idleString = new TiledSpritemap(STRINGTILE, 4, 2, 800, 2);
			movingString = new TiledSpritemap(STRINGTILE, 4, 2, 800, 2)
			
			movingString.alpha = 0.5;
			
			idleString.originX = 800;
			idleString.x = 800;
			movingString.x = 800;
			
			shadow = new Canvas(800, 2);
			shadow.fill(new Rectangle(0, 0, 800, 2), 0, 0.4);
			shadow.y = 2;
			
			this.graphic = new Graphiclist(shadow, idleString, movingString);
		}
		
		public function vibrateAt(x:Number):void
		{
			idleString.x = x;
			movingString.x = x;
		}
		
		public function press():void
		{
			idleString.y = 2;
			movingString.y = 2;
		}
		
		public function stopVib():void
		{
			idleString.x = 800;
			movingString.x = 800;
		}
		
		public function release():void
		{
			idleString.y = 0;
			movingString.y = 0;
		}		
		
	}

}