package com.game 
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Anim;
	import net.flashpunk.graphics.Graphiclist;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.graphics.Text;
	/**
	 * ...
	 * @author Arthur Zeferino
	 */
	public class HUD extends Entity
	{
		[Embed(source = '../../../resources/combobreaker.png')]
		protected static const BREAKSPT:Class;
		
		[Embed(source = '../../../resources/numbers.png')]
		protected static const NUMSPT:Class;
		
		[Embed(source = '../../../resources/currentStk.png')]
		protected static const STKSPT:Class;		
		
		protected var scoreViewer:Text;
		protected var comboBreakerSpt:Spritemap;
		protected var currentStreakSpt:Image;
		protected var combo0:Spritemap;
		protected var combo1:Spritemap;
		
		public function HUD() 
		{
			scoreViewer = new Text("0000000", 0, 0, { color: 0x4dfdfc, size: 20, align: "right", width:200 } );
			
			scoreViewer.x = 600;
			
			currentStreakSpt = new Image(STKSPT);
			currentStreakSpt.x = 60;
			currentStreakSpt.y = 160;
			
			combo0 = new Spritemap(NUMSPT, 21, 34);
			combo1 = new Spritemap(NUMSPT, 21, 34);
			
			comboBreakerSpt = new Spritemap(BREAKSPT, 308, 36);
			comboBreakerSpt.add("comboBreak", [0, 1, 2], 0.2, false);
			
			currentStreakSpt.visible = false;
			comboBreakerSpt.visible = false;
			combo0.visible = false;
			combo1.visible = false;
			
			comboBreakerSpt.x = 60;
			comboBreakerSpt.y = 160;
			
			combo0.x = currentStreakSpt.x + currentStreakSpt.width + 10;
			combo0.y = currentStreakSpt.y + 10;
			
			combo1.x = combo0.x + combo0.width + 1;
			combo1.y = combo0.y;			
			
			this.graphic = new Graphiclist(scoreViewer, currentStreakSpt, combo0, combo1, comboBreakerSpt);
		}
		
		override public function update():void
		{
			scoreViewer.text = "SCORE: "+String(ScoreManager.getInstance().score);
			
			var combo:int = ScoreManager.getInstance().comboCounter;
			
			if (combo > 2)
			{
				comboBreakerSpt.visible = false;
				currentStreakSpt.visible = true;
				
				var c0:int = combo / 10;
				var c1:int = combo % 10;
				
				if (c0 > 0)
				{
					combo0.visible = true;
					combo0.frame = c0;
				}
				
				combo1.visible = true;
				combo1.frame = c1;
			}
		}
		
		public function comboBreak():void
		{
			currentStreakSpt.visible = false;
			comboBreakerSpt.visible = true;
			combo0.visible = false;
			combo1.visible = false;
			
			comboBreakerSpt.play("comboBreak");
		}
		
	}

}