package com.game 
{
	import net.flashpunk.Tween;
	import net.flashpunk.tweens.misc.MultiVarTween;
	import net.flashpunk.tweens.motion.LinearMotion;
	import net.flashpunk.tweens.motion.Motion;
	import net.flashpunk.World;
	/**
	 * ...
	 * @author Arthur Zeferino
	 */
	public class NoteList 
	{
		protected var fretArray:Array;
		protected var fretColors:Array;
		
		public var fretBoard:FretBoard;
		
		public var stringPos:Number;
		
		public var worldPtr:World;
		
		public function NoteList() 
		{
			fretArray = new Array(8);
			
			for (var i:int = 0; i < fretArray.length; i++)
				fretArray[i] = new Array();
			
			fretColors = [0xff0000, 0x00ffff, 0xdd4400, 0x00ff00, 0x0000ff, 0xff00ff, 0xffff00, 0xffaaaa];
			worldPtr = null;
		}
		
		public function addNote(fret:int):Note
		{
			var note:Note = new Note();
			note.centerOrigin();
			note.color = fretColors[fret];
			
		//	note.scale = 0.3;
			
			note.x = FretBoard.FRETOFFSET + (FretBoard.FRETSIZE * fret);
			note.y = fretBoard.y - 200;
			
			var moveTween:MultiVarTween = new MultiVarTween();
			moveTween.tween(note, { y:600 }, 200);//, scale:1.0 }, 300);
			
			note.addTween(moveTween, true);
			
			fretArray[fret].push(note);
			
			return note;
		}
		
		public function getFretColor(fret:int):int
		{
			return fretColors[fret];
		}
		
		public function checkHit(fret:int):int
		{
			for (var i:int = 0; i < fretArray[fret].length; i++)
			{
				if (!fretArray[fret][i].used)
				{
					if (fretArray[fret][i].y < fretBoard.y)
					{ //ignore
						return 0;
					}
					else if (fretArray[fret][i].y < stringPos)
					{ //point!
						fretArray[fret][i].explode();
						
						var dist:Number = stringPos - fretArray[fret][i].y;
						
						if (dist < 10)
							return 300;
						else if (dist < 30)
							return 200;
						else
							return 100;
					}
				}
			}
			
			return 0;
		}
		
		public function update():void
		{
			var removeIndex:Array = new Array();
			
			for (var i:int = 0; i < fretArray.length; i++)
			{
				if (fretArray[i].length > 0 && fretArray[i][0].y >= 600) 
					removeIndex.push(i);
			}
			
			for (i = 0; i < removeIndex.length; i++)
			{
				if (!fretArray[removeIndex[i]][0].used)
					ScoreManager.getInstance().breakCombo();
				
				worldPtr.remove(fretArray[removeIndex[i]][0]);
				
				fretArray[removeIndex[i]].shift();
			}
		}
		
		public function get empty():Boolean
		{
			for (var i:int = 0; i < fretArray.length; i++)
			{
				if (fretArray[i].length > 0) 
					return false;
			}
			
			return true;
		}
		
	}

}