package com.game
{
	import net.flashpunk.Sfx;
	import net.flashpunk.tweens.sound.SfxFader;
	
	/**
	 * ...
	 * @author Arthur Zeferino
	 */
	public class NotePlayer 
	{
		[Embed(source = '../../../resources/notes/a_heavy.mp3')]
		private static const SFX_A:Class;
		
		[Embed(source = '../../../resources/notes/b_heavy.mp3')]
		private static const SFX_B:Class;
		
		[Embed(source = '../../../resources/notes/c_heavy.mp3')]
		private static const SFX_C:Class;

		[Embed(source = '../../../resources/notes/d_heavy.mp3')]
		private static const SFX_D:Class;
		
		[Embed(source = '../../../resources/notes/e_heavy.mp3')]
		private static const SFX_E:Class;
		
		[Embed(source = '../../../resources/notes/f_heavy.mp3')]
		private static const SFX_F:Class;
		
		[Embed(source = '../../../resources/notes/g_heavy.mp3')]
		private static const SFX_G:Class;
		
		[Embed(source = '../../../resources/notes/c2_heavy.mp3')]
		private static const SFX_C2:Class;
		
		[Embed(source = '../../../resources/notes/free_heavy.mp3')]
		private static const SFX_FREE:Class;
		
		
		private var noteArray:Array;
		private var faders:Array;
		
		public function NotePlayer():void
		{
			noteArray = new Array();
			
			noteArray[0] = new Sfx(SFX_C);
			noteArray[1] = new Sfx(SFX_D);
			noteArray[2] = new Sfx(SFX_E);
			noteArray[3] = new Sfx(SFX_F);
			noteArray[4] = new Sfx(SFX_G);
			noteArray[5] = new Sfx(SFX_A);
			noteArray[6] = new Sfx(SFX_B);
			noteArray[7] = new Sfx(SFX_C2);
			noteArray[8] = new Sfx(SFX_FREE);
			
			faders = new Array();
			for (var i:int = 0; i < noteArray.length; i++)
			{
				faders[i] = new SfxFader(noteArray[i]);
			}
			
		}
		
		public function play(index:uint, pos:Number = 0):void
		{
			for (var i:int = 0; i < noteArray.length; i++)
				noteArray[i].stop();
				
			faders[index].cancel();	
			noteArray[index].volume = 1.0;
 			noteArray[index].play(0.5, 0, 0.2);
		}
		
		public function update():void
		{
			for (var i:int = 0; i < noteArray.length; i++)
			{
				if (faders[i].active)
				{
					faders[i].update();
					//noteArray[i].volume = faders[i].volume;
				}
			}
		}
		
		public function stop(speed:Number):void
		{
			for (var i:int = 0; i < noteArray.length; i++)
			{
				if (noteArray[i].playing)
				{
					faders[i].fadeTo(0, speed);
				}
				
				//noteArray[i].stop();
			}
		}
		
		public function crossFadeto(prev:uint, freet:uint):void
		{
			if (noteArray[prev].playing)
			{
				if (noteArray[prev].position < noteArray[prev].length / 2)
				{
					noteArray[freet].play(0, 0, noteArray[prev].position+1.0);
					faders[freet].fadeTo(0.5, 200);
					faders[prev].fadeTo(0, 50);
				}
			}
		}
		
	}
	
}