package com.game 
{
	
	import net.flashpunk.FP;
	import flash.events.Event;
	import flash.geom.Rectangle;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Anim;
	import net.flashpunk.graphics.Canvas;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.Tween;
	import net.flashpunk.utils.Ease;
	import net.flashpunk.Sfx;
	import net.flashpunk.tweens.misc.ColorTween;
	import net.flashpunk.World;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	
	/**
	 * ...
	 * @author Arthur Zeferino
	 */
	public class StartScreen extends World
	{
		[Embed (source = '../../../resources/startBG.png')]
		protected static const STBG:Class;
		
		protected var finger:Finger;
		protected var fretBoard:FreetBoardMenu;
		protected var guitarString:GuitarString;
		
		protected var notePlayer:NotePlayer;		
		
		protected var pressed:Boolean;
		protected var endTween:ColorTween;
		
		protected var transition:Entity;
		protected var credits:Entity;
		
		protected var instructions:Entity;
		
		public function StartScreen() 
		{
			Input.mouseCursor = "hide";
			pressed = false;
			setSprites();
		}
		
		public function setSprites():void
		{
			finger = new Finger();
			
			notePlayer = new NotePlayer();
			
			fretBoard = new FreetBoardMenu();
			guitarString = new GuitarString();
			
			Input.define("strum", Key.SPACE, Key.ENTER, Key.UP, Key.DOWN, Key.W, Key.A, Key.S, Key.D);
			
			var transitionCanvas:Canvas = new Canvas(800, 600);
			transitionCanvas.fill(new Rectangle(0, 0, 800, 600), 0);
			transitionCanvas.alpha = 0;
			transition = new Entity(0, 0, transitionCanvas);
			
			fretBoard.y = 476;
			guitarString.y = 530;
			finger.y = 455;
			
			var bg:Entity = new Entity(0, 0, new Image(STBG));
			this.add(bg);
			
			credits = new Entity(0, 460, new Text("Arthur Zeferino 2013. Made with Flashpunk for Ludum Dare 26.", 0, 0, {size:12}));
			this.add(credits);
			
			this.add(fretBoard);
			
			this.add(guitarString);
			this.add(finger);
			
			this.add(transition);
			
			finger.visible = true;
		}
		
		override public function update():void
		{
			if (!pressed)
			{
				if (Input.mousePressed)
				{
					guitarString.stopVib();
					guitarString.press();
					finger.press();
				}
				else if (Input.mouseReleased)
				{
					finger.release();
					guitarString.stopVib();
					guitarString.release();
				}
				
				if (Input.pressed("strum"))
				{
					strum();
				}
				
				finger.x = mouseX;
				
				notePlayer.update();
				
			}
			else
			{
				Canvas(transition.graphic).alpha = endTween.alpha;
			}
			
			
			super.update();
		}	
		
		protected function strum():void
		{
			if (finger.pressing)
			{
				guitarString.vibrateAt(finger.x + 50);		
			}
			else
			{
				guitarString.vibrateAt(0);
			}
			
			notePlayer.play(8);	
			pressed = true;
			
			endTween = new ColorTween(enterGame, Tween.ONESHOT);
			endTween.tween(200, 0, 0, 0, 1);
			this.addTween(endTween, true);
		}
		
		protected function enterGame():void
		{
			if (finger.x < 400)
			{
				FP.world = new MainGame();
			}
			else
			{
				FP.world = new FreeMode();
			}
			
		}
	}

}