package com.game 
{
	import flash.geom.Rectangle;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Canvas;
	import net.flashpunk.graphics.Graphiclist;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.utils.Input;
	/**
	 * ...
	 * @author Arthur Zeferino
	 */
	public class StoryDisplay extends Entity
	{
		[Embed (source = "../../../resources/guitarplayer_portraits.png")]
		private static const GUITARPORTR:Class;
		
		[Embed (source = "../../../resources/man_protraits.png")]
		private static const MANPORTR:Class;		
		
		protected var blackAlpha:Canvas;
		protected var textWindow:Canvas;
		protected var dialogue:Text;
		
		protected var guitarAvatar:Spritemap;
		protected var manAvatar:Spritemap;
		
		protected var lines:Array;
		public var endCallBack:Function;
		
		public var showing:Boolean;
		
		public function StoryDisplay() 
		{
			blackAlpha = new Canvas(800, 600);
			blackAlpha.fill(new Rectangle(0, 0, 800, 600), 0x000000, 0.6);
			
			textWindow = new Canvas(790, 160);
			textWindow.fill(new Rectangle(0, 0, 790, 160), 0xffffff);
			textWindow.drawRect(new Rectangle(2, 2, 786, 156), 0x000099);
			textWindow.x = 5;
			textWindow.y = 600-160-2;
			
			guitarAvatar = new Spritemap(GUITARPORTR, 278, 300);
			manAvatar = new Spritemap(MANPORTR, 164, 300);
			
			endCallBack = null;
			
			guitarAvatar.x = 4;
			guitarAvatar.y = 150;
			
			manAvatar.x = 800-170;
			manAvatar.y = 140;
			
			dialogue = new Text("", 8, textWindow.y + 4, { color: 0xffffff, size: 25, wordWrap:true, width:776, height:100 } );
			
			this.graphic = new Graphiclist(blackAlpha,guitarAvatar,manAvatar,textWindow, dialogue);
			
			showing = true;
			
			guitarAvatar.visible = false;
			manAvatar.visible = false;
			
			lines = new Array();
		}
		
		public function addLine(str:String, av:String):void
		{
			lines.push({text:str, av:av});
		}
		
		public function start():void
		{
			showNextLine();
		}
		
		public function showNextLine():void
		{
			guitarAvatar.visible = false;
			manAvatar.visible = false;
			
			if (lines.length > 0)
			{
				var newLine:Object = lines.shift();
			
				dialogue.text = newLine.text;
				
				var avtoShow:Spritemap = null;
				if (newLine.av.charAt(0) == 'g')
					avtoShow = guitarAvatar;
				else if (newLine.av.charAt(0) == 'm')
					avtoShow = manAvatar;
					
				if (avtoShow != null)
				{
					avtoShow.visible = true;
					avtoShow.frame = int(newLine.av.charAt(1));
				}
					
			}
			else
			{
				if (endCallBack != null)
					endCallBack();
					
				showing = false;
			}
		}
		
		override public function update():void
		{
			if (Input.mouseReleased)
			{
				showNextLine();
			}
			
			super.update();
		}
	}

}